=== debian/control ===
Source: synergy
Section: utils
Priority: optional
Standards-Version: 3.9.7
Homepage: https://www.symless.com/
Maintainer: Symless <engineering@symless.com>

Package: synergy
Architecture: amd64
Section: utils
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Keyboard and mouse sharing solution
 Synergy allows you to share one mouse and keyboard between multiple computers.
 Work seamlessly across Windows, macOS and Linux.
Homepage: https://symless.com/synergy
